<style>

    .category {
        padding-left: 3px;
        padding-top: 5px;
        padding-bottom: 5px;
    }
    .new.category {
        color: #777;
        cursor: pointer;
    }
    .new.category:hover {
        color: #000;
    }

    .category:not(.sub) {
        border-top: 1px #ddd solid;
    }

    .sub.category {
        padding-top: 1px;
        padding-bottom: 1px;
        padding-left: 18px;
    }

    .category span {
        padding: 8px 0;
        display: inline-block;
    }
    .category a {
        padding: 8px 8px;
        font-size: 80%;
        float: right;
        display: inline-block;
        color: #777;
    }

    .category a:hover {
        color: #000;
        text-decoration: none;
    }

    .category a.inactive, .category a:hover.inactive {
        color: #ddd;
    }

    .category:hover {
        background-color: #f5f5f5;
    }

    @media (max-width: 499px){
        .category {
            padding-top: 10px;
            padding-bottom: 10px;
        }

        .sub.category {
            padding-top: 8px;
            padding-bottom: 8px;
        }

        .category a {
            padding: 8px 10px;
        }

    }
</style>

<div class="node">
    <div class="align-center">
        <div class="form-container" style="margin-bottom: 10px; max-width: 420px">

            <h1>Edit brand menu</h1>

            <div class="categoryList"></div>

            <div style="margin-top: 5px; float: right; color: #777;"><p id="updateInfo">&nbsp;</p></div>
        </div>
    </div>
</div>

<script>

    var categoryList = <?= json_encode($this->categoryList) ?>;

    categoryList = categoryList.sort(function(a, b){return a.weight - b.weight});

    for(var k in categoryList) {
        categoryList[k].children = categoryList[k].children.sort(function(a, b){return a.weight - b.weight});
    }

    function fixWeights() {
        var weight = 10;
        for(var k in categoryList) {
            categoryList[k].weight = weight;
            weight += 10;
            for(var j in categoryList[k].children) {
                categoryList[k].children[j].weight = weight;
                weight += 10;
            }
        }
    }

    var timeout = null;
    function redrawFromJson(dontSave) {
        var $list = $(".categoryList");
        $list.empty();

        for(var k in categoryList) {
            var cat = categoryList[k];
            var canMoveUp = (k != 0);
            var canMoveDown = (k != categoryList.length-1);

            $list.append($.parseHTML('<div class="category"><span>' + cat['label'] + '</span> ' +
                '<a title="Delete" data-glyph="x" class="oi" href="#" onclick="removeCategory(' + k + ')"></a> ' +
                '<a title="Rename" data-glyph="pencil" class="oi" href="#" onclick="renameCategory(' + k + ')"></a> ' +
                '<a title="Move down" data-glyph="chevron-bottom" class="oi ' + (canMoveDown ? '' : 'inactive') + '" href="#" onclick="moveDown(' + k + ')"></a> ' +
                '<a title="Move up" data-glyph="chevron-top" class="oi ' + (canMoveUp ? '' : 'inactive') + '" href="#" onclick="moveUp(' + k + ')"></a>' +
                '<a title="Add subcategory" data-glyph="plus" class="oi" href="#" onclick="addSubcategory(' + k + ')"></a></div>'));

            for(var j in cat.children) {
                var sub = cat.children[j];
                canMoveUp = (j != 0);
                canMoveDown = (j != cat.children.length-1);
                $list.append($.parseHTML('<div class="sub category"><span>' + sub.label + '</span> ' +
                    '<a title="Delete" data-glyph="x" class="oi" href="#" onclick="removeCategory(' + k + ', ' + j + ')"></a> ' +
                    '<a title="Rename" data-glyph="pencil" class="oi" href="#" onclick="renameCategory(' + k + ', ' + j + ')"></a> ' +
                    '<a title="Move down" data-glyph="chevron-bottom" class="oi ' + (canMoveDown ? '' : 'inactive') + '" href="#" onclick="moveDown(' + k + ', ' + j + ')"></a> ' +
                    '<a title="Move up" data-glyph="chevron-top" class="oi ' + (canMoveUp ? '' : 'inactive') + '" href="#" onclick="moveUp(' + k + ', ' + j + ')"></a></div>'));
            }
        }
        $list.append($.parseHTML('<div class="new category" onclick="addCategory()"><span class="oi" data-glyph="plus">Add new category</span>'));
        if(!dontSave) {
            if (timeout != null) {
                window.clearTimeout(timeout);
            }
            timeout = window.setTimeout(sendUpdate, 2000);
            $('#updateInfo').text("Saving...");
        }
    }

    function sendUpdate() {
        // Deep copy
        var rawCategoryList = jQuery.extend(true, {}, categoryList);

        for(var k in rawCategoryList) {
            rawCategoryList[k].label = htmlunescapespecialchars(rawCategoryList[k].label);

            for(var j in rawCategoryList[k].children) {
                rawCategoryList[k].children[j].label = htmlunescapespecialchars(rawCategoryList[k].children[j].label);
            }
        }

        ajaxSubmit("<?= $this->url('root/saveBrandCategories', ['brandUrl' => $this->thisBrand->url]) ?>", { categories: rawCategoryList }, function(data){
            if(!data || !data.status || data.status != 'ok') {
                if(data && data.status) {
                    $('#updateInfo').text("Error: " + data.status);
                }else{
                    $('#updateInfo').text("An error has occurred while saving.");
                }
            }else{
                $('#updateInfo').text("Saved");
            }
            timeout = window.setTimeout(function(){
                $('#updateInfo').html("&nbsp;");
            }, 3000);
        });
    }

    function moveUpOperator(categories, idx) {
        if(idx == 0) return categories;
        var temp = categories[idx];
        categories[idx] = categories[idx-1];
        categories[idx-1] = temp;

        return categories;
    }

    function moveUp(idx, subidx) {
        if(subidx === void 0) {
            categoryList = moveUpOperator(categoryList, idx);
        }else{
            categoryList[idx].children = moveUpOperator(categoryList[idx].children, subidx);
        }

        fixWeights();
        redrawFromJson();
    }

    function moveDownOperator(categories, idx) {
        if(idx == categories.length-1) return categories;
        var temp = categories[idx];
        categories[idx] = categories[idx+1];
        categories[idx+1] = temp;

        return categories;
    }

    function moveDown(idx, subidx) {
        if(subidx === void 0) {
            categoryList = moveDownOperator(categoryList, idx);
        }else{
            categoryList[idx].children = moveDownOperator(categoryList[idx].children, subidx);
        }

        fixWeights();
        redrawFromJson();
    }

    function addSubcategory(idx) {
        var parentCat = categoryList[idx];
        var newId = 'new' + Math.floor(Math.random()*10000000);

        var moveNotice = '';
        if(parentCat.children.length == 0) {
            moveNotice = "Warning: All existing posts from \""+parentCat.label+"\" will be moved to the newly created category!";
        }
        labPrompt(moveNotice, "Create a subcategory", function(label) {
            if(!label) return;
            if(parentCat.children.length == 0) {
                var oldLabel = parentCat.label;
                parentCat.label = label;
                categoryList[idx] = {
                    id: newId,
                    label: oldLabel,
                    weight: 100000,
                    children: [parentCat]
                }
            }else{
                categoryList[idx].children.push({
                    id: newId,
                    label: label,
                    weight: parentCat.children[parentCat.children.length - 1].weight + 100000,
                    children: []
                })
            }

            fixWeights();
            redrawFromJson();
        }, "Category name", "Enter the name of the new category", null, "Create", "Cancel");
    }

    function addCategory() {
        var newId = 'new' + Math.floor(Math.random()*10000000);
        labPrompt("Create a category", null, function(label) {
            if (!label) return;


            categoryList.push({
                id: newId,
                label: label,
                weight: categoryList.length > 0 ? categoryList[categoryList.length - 1].weight + 100000 : 100000,
                children: []
            });
            fixWeights();
            redrawFromJson();
        }, "Category name", "Enter the name of the new category", null, "Create", "Cancel");
    }

    function renameCategory(idx, subidx) {
        if(subidx === void 0) {
            labPrompt("Rename a category", null, function(name){
                if(!name) return;
                categoryList[idx].label = htmlspecialchars(name);
                redrawFromJson();
            }, "New category name", "Enter new category name here", htmlunescapespecialchars(categoryList[idx].label), "Rename", "Cancel");
        }else{
            labPrompt("Rename a category", null, function(name){
                if(!name) return;
                categoryList[idx].children[subidx].label = htmlspecialchars(name);
                redrawFromJson();
            }, "New category name", "Enter new category name here", htmlunescapespecialchars(categoryList[idx].children[subidx].label), "Rename", "Cancel");
        }
    }

    function removeCategory(idx, subidx) {
        if(subidx === void 0) {
            if(categoryList[idx].children.length > 0) {
                labAlert("You cannot remove a category with subcategories.\nPlease remove the subcategories first.", "Error");
                return;
            }
            labConfirm("Do you really want to delete \"" + categoryList[idx].label + "\"?\nThis will irreversibly remove ALL posts in this category.", "Are you sure?", function(response) {
                if(response) {
                    categoryList.splice(idx, 1);
                    redrawFromJson();
                }
            }, "Delete", "Cancel");
        }else{
            labConfirm("Do you really want to delete \"" + categoryList[idx].children[subidx].label + "\"?\nThis will irreversibly remove ALL posts in this category.", "Are you sure?", function(response) {
                if(response) {
                    categoryList[idx].children.splice(subidx, 1);
                    redrawFromJson();
                }
            }, "Delete", "Cancel");
        }
    }

    $(function(){
        redrawFromJson(true);
    });
</script>